//+------------------------------------------------------------------+
//|                                                          DVI.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
// Coding Julien Moog
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue

double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexBuffer(0,ExtMapBuffer1);   
SetIndexStyle(0,DRAW_LINE,0,1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(),i,limit;
   double midpoint,dv,dvu;
   dv=0;
      
//----
  
  limit=Bars-counted_bars-1;
   for(i=limit;i>=0;i--)
   {   
   midpoint = ( High[i] + Low[i] ) / 2; 
   midpoint += ( High[i+1] + Low[i+1] ) / 2;  
   midpoint += ( High[i+2] + Low[i+2] ) / 2;  
   midpoint += ( High[i+3] + Low[i+3] ) / 2;  
   midpoint += ( High[i+4] + Low[i+4] ) / 2;  
   midpoint=midpoint/5;
   
   dvu=Volume[i] * (High[i]-Low[i]);
      dvu=dvu+Volume[i+1] * (High[i+1]-Low[i+1]);
      dvu=dvu+Volume[i+2] * (High[i+2]-Low[i+2]);
      dvu=dvu+Volume[i+3] * (High[i+3]-Low[i+3]);
      dvu=dvu+Volume[i+4] * (High[i+4]-Low[i+4]);
      dvu=dvu/5;
      dvu=dvu*0.02;
      
      dv = Volume[i] * (( Close[i] - midpoint ) / midpoint);
      dv=dv/dvu;
   
   ExtMapBuffer1[i]=ExtMapBuffer1[i+1]+dv;
}
//----
   return(0);
  }
//+------------------------------------------------------------------+